#include <amxmodx>
#include <amxmisc>
#include <sqlx>
#include <sockets_hz>
#include <celltrie>

#define PLUGIN "Extreme Banconfig"
#define VERSION "4.0"
#define AUTHOR "R3X"

#define TASKID_LISTENING 3456

#define BUILDURL "http://%s/%s?id=%d"

#define DISCONNECTED_FLAG 64

new giMaxPlayers;


new bool:gbFirstMOTD[33];

new listenSocket;

new gszHeader[9] = "##9@edR_";
new gszHost[32] = "127.0.0.1";
new giPort = 27005;
new gszFile[64] = "report2.php";

new gszNewAuthid[33][32];
new gszNicks[33][32];

new gszAdminBanAuthid[33][32];

//Disconnect
new Array:gDiscAuths;
new Array:gDiscNicks;
new Trie:gAuths;

new gszError[128];

enum{
	TYPE_FILE,
	TYPE_MYSQL,
	TYPE_GM15,
	TYPE_GM16
};

#include "modes/config.inl"
#include "modes/file.inl"
#include "modes/mysql.inl"
#include "modes/gm15.inl"
#include "modes/gm16.inl"

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	
	register_message(get_user_msgid("MOTD"), "messageMOTD");
	
	register_concmd("status_ebc", "cmdPlayerList", ADMIN_BAN, "lista graczy i ich ban");
	register_concmd("amx_ebc_config", "cmdEBCConfig", ADMIN_CFG, "konfiguracja extreme banconfig");
	
	register_concmd("amx_bancfg", "cmdBanCfg", ADMIN_BAN, "<nick> <czas> [Powod]");
	
	register_dictionary("admincmd.txt");
	
	giMaxPlayers = get_maxplayers();
	
	gDiscAuths = ArrayCreate(32);
	gDiscNicks = ArrayCreate(32);
	gAuths = TrieCreate();
}

public plugin_cfg(){
	parseConfig();
	
	new error;
	listenSocket = socket_listen(gszHost, giPort, SOCKET_UDP, error);
	
	if(listenSocket < 1)
		log_amx("Error = %d", error);
	else
		set_task(1.0, "taskReceive", TASKID_LISTENING,_, _, "b");
		
	loadConfig();
	loadBanlist();
}

public cmdMyNewAuth(id){
	client_print(id, print_chat, "Twoje nowe authid = %s", gszNewAuthid[id]);
	return PLUGIN_HANDLED;
}

public taskReceive(){
	static szData[256];
	
	if( socket_change(listenSocket, 100) ){
		socket_recv(listenSocket, szData, 255);
		
		client_print(0, print_console, "Recv = %s", szData);
		
		new szHeader[9];
		new szId[4];
		if(3 != parse(szData, szHeader, 8, szId, 3, szData, 40))
			return;
			
		if(!equal(szHeader, gszHeader))
			return;
		
		new id = str_to_num(szId);
		
		if(!is_user_connected(id) || gszNewAuthid[id][0])
			return;
			
		copy(gszNewAuthid[id], 31, szData);
		client_new_authorized(id);
	}
}


public client_connect(id){
	gbFirstMOTD[id] = true;
	gszNewAuthid[id][0] = '^0';
}
public client_infochanged(id){
	new szNewname[32], szOldname[32]
	get_user_info(id, "name", szNewname,31)
	get_user_name(id, szOldname,31);
	
	if(!equal(szOldname, szNewname))
		copy(gszNicks[id], 31, szNewname);
}
public client_disconnect(id){
	new index;
	if(TrieGetCell(gAuths, gszNewAuthid[id], index))
		ArraySetString(gDiscNicks, index&(~DISCONNECTED_FLAG), gszNicks[id]);
	else{
		ArrayPushString(gDiscAuths, gszNewAuthid[id]);
		ArrayPushString(gDiscNicks, gszNicks[id]);
		
		TrieSetCell(gAuths, gszNewAuthid[id], (ArraySize(gDiscAuths)-1)|DISCONNECTED_FLAG);
	}
}
client_new_authorized(id){
	new szName[32];
	get_user_name(id, szName, 31);
	client_print(0, print_chat, "Gracz %s zostal zweryfikowany jako: %s", szName, gszNewAuthid[id]);
	
	TrieSetCell(gAuths, gszNewAuthid[id], id);
	
	checkBanned(id);
	
	get_user_name(id, gszNicks[id], 31);
}
client_banned(id, const szReason[]){
	show_motd(id, "Masz bana, bo", szReason);
}

public messageMOTD(msg_dest, msg_type, id){
	static szLink[64];
	if(is_user_bot(id) || !is_user_connected(id) || !gbFirstMOTD[id])
		return PLUGIN_CONTINUE;
	
	if(get_msg_arg_int(1)){
		gbFirstMOTD[id] = false;
		gszNewAuthid[id][0] = '^0';
		
		formatex(szLink, 63, BUILDURL, gszHost, gszFile, id);
		show_motd(id, szLink);
	}

	return PLUGIN_HANDLED;
}

public plugin_end(){
	socket_close(listenSocket);
} 


BanPlayer(admin, player, iLength, const szReason[]){	
	new szName[32];
	get_user_name(player, szName, 31);
	
	BanAuthid(admin, gszNewAuthid[player], szName, iLength, szReason);
	client_banned(player, szReason);
	return 1;
}

public cmdPlayerList(id, level, cid){
	if(!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;
		
	console_print(id, "Aktualnie podlaczeni");
	for(new i=1;i<=giMaxPlayers;i++){
		if(is_user_connected(i)){
			console_print(id, "^t%d. %32s [ %s ]", i, gszNicks[i], gszNewAuthid[i]);
		}
	}
	console_print(id, "Byli na serwerze");
	new iSize = ArraySize(gDiscAuths);
	for(new i=0;i<iSize;i++){
		ArrayGetString(gDiscAuths, i, gszNewAuthid[0], 31);
		ArrayGetString(gDiscNicks, i, gszNicks[0], 31);
		console_print(id, "^t%d. %32s '%s'", i+1, gszNicks[0], gszNewAuthid[0]);
		
	}
	return PLUGIN_HANDLED;
}

public cmdBanCfg(id, level, cid){
	if(!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED;
		
	new szTarget[32];
	read_argv(1, szTarget, 31);
	
	new iTarget = find_player("bl", szTarget);
	if(is_user_connected(iTarget)){
		if(is_user_bot(iTarget)){
			get_user_name(iTarget, szTarget, 31);
			console_print(id,"%L", id,"CANT_PERF_BOT", szTarget);
			return PLUGIN_HANDLED;
		}
		if(get_user_flags(id)&ADMIN_IMMUNITY){
			get_user_name(iTarget, szTarget, 31);
			console_print(id,"%L",id,"CLIENT_IMM", szTarget);
			return PLUGIN_HANDLED;
		}
	}
	else{
		if(!TrieGetCell(gAuths, szTarget, iTarget)){
			if(equal(gszAdminBanAuthid[id], szTarget))
				iTarget = -1;
			else{
				copy(gszAdminBanAuthid[id], 31, szTarget);
				
				console_print(id, "Podany klucz nie pasuje do zadnego gracza, ktory \
				jest teraz na serwerze, ani nawet byl na tej mapie.");
				console_print(id, "Chcesz zbanowac podany klucz (%s)? Jesli tak, \
				uzyj ponownie ten komendy (strzalka w gore + enter)", szTarget);
			}
			return PLUGIN_HANDLED;
		}
	}
	
	new iLen, szReason[32] = ""
	new szTime[32];
	read_argv(2, szTime, 31);
	
	iLen = abs(str_to_num(szTime))
	if(read_argc() >= 4)
		read_argv(3, szReason, 31);
	

	if(iTarget == -1){
		log_amx("Custom %s", gszAdminBanAuthid[id]);
		BanAuthid(id, gszAdminBanAuthid[id], "???", iLen, szReason);
	}
	else if(iTarget&DISCONNECTED_FLAG){
		iTarget = iTarget&(~DISCONNECTED_FLAG);
		
		ArrayGetString(gDiscAuths, iTarget, gszNewAuthid[0], 31);
		ArrayGetString(gDiscNicks, iTarget, gszNicks[0], 31);

		BanAuthid(id, gszNewAuthid[0], gszNicks[0], iLen, szReason);
	}else
		BanPlayer(id, iTarget, iLen, szReason);
	
	return PLUGIN_HANDLED;
}

BanPrintInfo(admin, const szNick[], iLength, const szReason[] = ""){
	new szAdminName[32];
	get_user_name(admin, szAdminName, 31);
	for(new i=1; i<=giMaxPlayers; i++)
		if(is_user_connected(i))
			BanPrintPlayerInfo(i, admin, szAdminName, szNick, iLength, szReason);
}
//based on admincmd.sma
BanPrintPlayerInfo(id, admin, const szAdminName[], const szNick[], iLength, const szReason[] = ""){
	static msg[198];
	static szMinutes[32];
	
	
	new len = formatex(msg, charsmax(msg), "%L", id, "BAN");
	len += formatex(msg[len], charsmax(msg) - len, " %s ", szNick);
	if (iLength){
		formatex(szMinutes, 31, "%d", iLength);
		len += formatex(msg[len], charsmax(msg) - len, "%L", id, "FOR_MIN", szMinutes);
	}
	else
		len += formatex(msg[len], charsmax(msg) - len, "%L", id, "PERM");
	if(szReason[0])
	{
		formatex(msg[len], charsmax(msg) - len, " (%L: %s)", id, "REASON", szReason);
	}
	
	show_activity_id(id, admin, szAdminName, msg);
}
